[<img src="https://sling.apache.org/res/logos/sling.png"/>](https://sling.apache.org)

 [![Build Status](https://builds.apache.org/buildStatus/icon?job=Sling/sling-org-apache-sling-feature-apiregions/master)](https://builds.apache.org/job/Sling/job/sling-org-apache-sling-feature-apiregions/job/master) [![Test Status](https://img.shields.io/jenkins/t/https/builds.apache.org/job/Sling/job/sling-org-apache-sling-feature-apiregions/job/master.svg)](https://builds.apache.org/job/Sling/job/sling-org-apache-sling-feature-apiregions/job/master/test_results_analyzer/) [![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://www.apache.org/licenses/LICENSE-2.0) [![feature](https://sling.apache.org/badges/group-feature.svg)](https://github.com/apache/sling-aggregator/blob/master/docs/groups/feature.md)

# Apache Sling API Regions runtime component

The API Regions runtime component is implemented as an OSGi Framework Extension bundle.
This ensures that the runtime component is always present early in the startup process.

This component registers an OSGi resolver hook service which enforces the API regions at runtime. The component looks for properties files that provide the configuration of the API regions. The properties files are generated by the https://github.com/apache/sling-org-apache-sling-feature-extension-apiregions component during the extension post-processing.

As the component has no dependencies on any other component, the properties files are obtained via Framework Properties lookups:

* `sling.feature.apiregions.resource.idbsnver.properties` - provides the location of the `idbsnver.properties` file.
* `sling.feature.apiregions.resource.bundles.properties` - provides the location of the `bundles.properties` file.
* `sling.feature.apiregions.resource.features.properties` - provides the location of the `features.properties` file.
* `sling.feature.apiregions.resource.regions.properties` - provides the location of the `regions.properties` file.

Alternatively, the directory where all of the above files can be found can be specified using one Framework Property instead of using
the above framework properties:

* `sling.feature.apiregions.location` - provides the location where all properties file can be found. If this property is specified the above properties are not necessary. However if both are provided the file-specific properties take precedence.

File locations are either provided as an absolute file path or by URL. The URL handling mechanism supports one special pseudo-protocol:
`classloader://`. URLs specified with this protocol are passed through the framework classloader's `getResource()` method to obtain
the actual URL. 

## Enabling / disabling this component
The component is enabled by setting the following framework property:

    org.apache.sling.feature.apiregions.regions=*

If this framework property is not set the component will be disabled.
